#import <ObjFW/ObjFW.h>
#import <ObjXMPP/ObjXMPP.h>

#import "JubUI.h"
#import "linenoise.h"

@class JubCLIChatUI;
@class JubChatClient;
@protocol JubCLICommand;

@interface JubCLIUI: OFObject <JubUI, XMPPContactManagerDelegate>
{
	XMPPContact *_lastIn;
	JubCLIChatUI *_sink;
	JubChatClient *_client;
	XMPPContactManager *_contactManager;
	OFMutableDictionary *_commands;
	OFMutableSet *_subRequests;
}
@property (readonly) JubChatClient *client;
@property (readonly) XMPPContact *lastIn;
@property (retain) JubCLIChatUI *sink;
@property (readonly) OFMutableSet *subRequests;

- (bool)Jub_userInputWithStream: (OFStream*)stream
			   line: (OFString*)line
		      exception: (OFException*)exception;
- (void)addCommand: (id<JubCLICommand>)command;
@end
